;      ,
;    
;      
;       "

; "v.1.03"
;
; FASM version 1.49
;----------------------------------------

	format MZ
	heap 0
	entry main:beg

include 'wrbmac.inc'

segment main use16

BootLen = 512		;  
MAXFILESIZE = 18*512	; 18     

MSG_OK		     = 0
MSG_USAGE	     = 1
MSG_OPENFILE	     = 2
MSG_READ	     = 3
MSG_LSEEK	     = 4
MSG_LEN 	     = 5
MSG_WRITE	     = 6
msgwratt	     = 7
MSG_PARAM_ERROR      = 8
MSG_PARAM_ERROR_2    = 9
MSG_LEN2	     = 10
MSG_WSECTOR	     = 11	;  a  

;******* START ******
beg:
	mov ax,ds
	push cs cs
	pop ds es
	mov [PSPaddr],ax

	mov dx,_logo
	mov ah,9
	int 21h 		;DOS  9h

;       ( )
	call get_file_name
	cmp [ERROR],MSG_OK
	jne error_exit

;  
	mov [ERROR],MSG_OPENFILE
	mov ah,3dh	      ; DOS n 3dh: OPEN FILE
	mov al,0	      ;  
	mov dx,param
	int 21h 	      ; OPEN
	jc error_exit	      ;   
	mov bx,ax	      ; file handle
	mov [fhandle],bx

;   
	mov ax,4202h	      ; al=2:   cx=0 dx=0
	xor cx,cx
	mov dx,cx
	int 21h
	jc err_1	      ; 
	mov word ptr filelen,ax     ; dx:ax   
;---
	cmp dx,0		;    9  (18 )
	jz  @f
	jmp mlenerr
@@:	cmp ax,MAXFILESIZE
	jle doon2
mlenerr:
	mov [ERROR],MSG_LEN2
	jmp closef
doon2:
	cmp ax,0		;   
	je mlenerr
	mov ax,4200h		     ;    
	xor cx,cx
	mov dx,cx
	int 21h
	jc err_1
	jmp rd_m
err_1:
	mov [ERROR],MSG_LSEEK
	jmp closef
;===========================
; read file
rd_m:
	mov [readlen],BootLen
;        mov [snumb],1                ;   (  1)

rd_1:
	cmp [filelen],BootLen	      ; = 512
	jge  @f 		      ; >=
	mov ax,[filelen]	      ;    
	mov [readlen],ax
@@:
	mov ah,3fh	      ;  READ from FILE
	mov cx,[readlen]      ; -  
	mov dx,buf	      ; 
	mov bx,[fhandle]
	int 21h 	      ; READ
	mov [ERROR],MSG_READ  ;  ERROR
	jc closef

	cmp ax,[readlen]	;   -?
	mov [ERROR],MSG_LEN
	jne closef		; 

	sub [filelen],ax	;   

;   
;~~~~~~~~~~~~~~~~~~~~~
;  13h  03 -  
;     AH    03H
;     AL    - 
;     CH      ()-   
;     CL      -   
;     DL    : 0-3=; 80H-81H =  
;     DH     
;     ES:BX   

	mov   ax,3	    ;    
attwr:
	push  ax
	mov   ax,0301h	  ;  1 
	mov   cx,[snumb]  ;    ( )
	mov   dh,0	  ;  
	mov   dl,0	  ;  = 'A'
	mov   bx,buf	  ; es:bx - 
	int   13h
	jc    mtry	  ;  
	jmp   wrok
mtry:
	xor ax,ax	  ;    
	int 13h

	mov dx,wratt		 ;    
	mov ah,9
	int 21h 		 ;   
;
	pop   ax
	dec   ax		 ;   - 1
	or    ax,ax		 ; =0 ?
	jnz   attwr		 ; 

	mov   [ERROR],MSG_WRITE    ;   
	jmp   closef

wrok:				; 
	pop   ax
	inc   [snumb]

	mov   [ERROR],MSG_WSECTOR	; ,   
	msg

	cmp   [filelen],0		;   ?
	jnz   rd_1			; 

	mov   [ERROR],MSG_OK	;  
	jmp   closef
;~~~~~~~~~~~~~~~~~~~~~~~~
; close file
closef:
	mov ah,3eh	      ;  CLOSE FILE
	int 21h 	      ;
	msg
exit:
	xor ax,ax	      ; reset controller AH=0
	int 13h

	mov	ah,4Ch
	int	21h	      ;   DOS

error_exit:
	msg
	jmp exit

;=========PROC==========

get_file_name:
;      
	push ds
	mov  ds,[PSPaddr]
	mov  cl,[80h]
	cmp  cl,0
	mov  [es:ERROR],MSG_USAGE
	je   gfn.end

	mov  si,81h		; ds:si   PSP + 81h
	mov  di,param		; es:di

;   ( )
copy_param_row:
.ltrim:
	lodsb			; al <- [ds:si]; si=si+1
	cmp  al,20h		; 
	je  .ltrim
	cmp  al,0Dh		; <CR>
	je  gfn.end
	cmp  al,'"'		;   
	jne  m3
m4:				; "parameter"
	lodsb
	cmp  al,0Dh
	mov  [es:ERROR],MSG_PARAM_ERROR
	je  gfn.end
	cmp  al,'"'
	je  m2
m5:	stosb
	jmp  m4
	display ''
m3:
	stosb			; al -> [es:di]; di=di+1
m1:	lodsb
	cmp  al,'"'
	mov [es:ERROR],MSG_PARAM_ERROR_2
	je  gfn.end
	cmp  al,20h
	je  m2
	cmp  al,0Dh
	je  m2
	stosb
	jmp  m1

m2:	mov  al,0		;  ASCIIZ ( )
	stosb			; 0 -> [es:di]
	mov  [es:ERROR],MSG_OK

gfn:
.end:	pop  ds
	ret
;===========================

VERSION_STRING equ "v.1.03"
_logo db 'wrboot_m: Writing data from file into floppy . ',VERSION_STRING,0Dh,0Ah,'$'

PSPaddr  dw  0	     ; save PSP segment addresse
ERROR	 dw  MSG_OK
fhandle  dw  0
filelen  dw  0
	 dw  0
readlen  dw  0
snumb	 dw  1	     ;  

tblmsg:
	addrtbl2 donestr,errstr,openstr,readstr,lseekstr,\
		 lenstr,wrstr,wratt,param_err_str,param_err2_str,\
		 lenstr2,wsector

t0:
donestr  db 0ah,0dh,'Program terminate successful',0ah,0dh,'$'
errstr	 db 0ah,0dh,'For write BOOT sector use: WRBOOT.EXE FNAME.EXT$'
openstr  db 0ah,0dh,'Open failed','$'
readstr  db 0ah,0dh,'Read failed','$'
lseekstr db 0ah,0dh,'Lseek failed','$'
lenstr	 db 0ah,0dh,'FileSize dont equal 512 bytes','$'
wrstr	 db 0ah,0dh,'Floppy writing error','$'
wratt	 db 0ah,0dh,'Next attempt to write bootsector$'
param_err_str	db  0ah,0dh,'Second quotation mark <"> need ! $'
param_err2_str db  0ah,0dh,'Non suitable simbol <"> found $'
lenstr2  db 0ah,0dh,'File size exceed a 9Kb (512*18) $'
wsector  db 0ah,0dh,'Sector writing $'

param rb 100h
buf  rb  200h

